<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2012 PIT Solutions <sivaprasad.s@pitsolutions.com>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'Cookie Control' for the 'cookie_control' extension.
 *
 * @author	PIT Solutions <sivaprasad.s@pitsolutions.com>
 * @package	TYPO3
 * @subpackage	tx_cookiecontrol
 */
class tx_cookiecontrol_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_cookiecontrol_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_cookiecontrol_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'cookie_control';	// The extension key.
	//var $pi_checkCHash = true;

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content, $conf) {


		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_USER_INT_obj = 1;

		/*
		 * Fetching the flex form content
		 */
		$flexformValues = $this->init();
		$templateID = $flexformValues['templateSelection'];
		//var_dump($templateID) ; exit;
		if($templateID !=""){
			$template = $this->cObj->fileResource($templateID);
		}else{
			$template = $this->cObj->fileResource('EXT:'.$this->extKey.'/pi1/template.html');
		}
		$tmpl = $this->cObj->getSubpart($template, '###COOKIE###' );


		/*
		 * Configuration for cookieControl plug-in
		 *
		 */		
		$iconPosition = $flexformValues['iconPosition']?$flexformValues['iconPosition']:$this->conf['iconPosition'];
		$iconTheme = $flexformValues['iconTheme']?$flexformValues['iconTheme']:$this->conf['iconTheme'];
		$iconType = $flexformValues['iconType']?$flexformValues['iconType']:$this->conf['iconType'];
		$extraoptions = $flexformValues['extra_options']?$flexformValues['extra_options']:$this->conf['extra_options'];
		$countries = ($flexformValues['countryField'] != "") ?$flexformValues['countryField']:$this->conf['countryField'];
		$anlayticsCode = $flexformValues['anlayticsCode'];
		$consentModel = $flexformValues['consentModel']?$flexformValues['consentModel']:$this->conf['consentModel'];
		/*
		 * Setting theme
		 */
		if($flexformValues['themeSelect'] == "default"){
			$iconTheme = "light";
		}else{
			$iconTheme = "dark";
		}
		/*
		 * Setting the rte content
		 */
		//$rte_introductory_text = $this->cObj->parseFunc($introductory_text,$GLOBALS['TSFE']->tmpl->setup['lib.']['parseFunc_RTE.']);
		//$rte_additional_text = $this->cObj->parseFunc($additional_text,$GLOBALS['TSFE']->tmpl->setup['lib.']['parseFunc_RTE.']);
		$flexformValues['introductory_text'] = str_replace(array("\r", "\n"), '', addslashes($flexformValues['introductory_text']));
		$introductory_text = ($flexformValues['introductory_text'] != "") ?$flexformValues['introductory_text']:$this->pi_getLL('introductory_text');
	
		$flexformValues['additional_text'] = str_replace(array("\r", "\n"), '', addslashes($flexformValues['additional_text']));
		$additional_text = ($flexformValues['additional_text'] != "") ?$flexformValues['additional_text']:$this->pi_getLL('additional_text');
		
		if($flexformValues['themeSelect'] == 4){
			$markerArray['###THEMEFILE###'] = $flexformValues['customThemeSelect'];
		}
		/*
		 * Replacing the markers in the template file
		 */
		if($flexformValues['themeSelect'] == 0 && $flexformValues['themeSelect'] != 4){
			$iconTheme = "light";
			$markerArray['###THEMEFILE###'] =  t3lib_extMgm::siteRelPath($this->extKey).'pi1/css/'.$this->conf['blueTheme'];
		}
		if($flexformValues['themeSelect'] == 2 && $flexformValues['themeSelect'] != 4){
			$iconTheme = "dark";
			$markerArray['###THEMEFILE###'] = t3lib_extMgm::siteRelPath($this->extKey).'pi1/css/'.$this->conf['blackTheme'];
		}
		if($flexformValues['themeSelect'] ==1 && $flexformValues['themeSelect'] !=4){
			$iconTheme = "light";
			$markerArray['###THEMEFILE###'] = t3lib_extMgm::siteRelPath($this->extKey).'pi1/css/'.$this->conf['greyTheme'];
		}
		if($flexformValues['themeSelect'] == 3 && $flexformValues['themeSelect'] != 4){
			$iconTheme = "light";
			$markerArray['###THEMEFILE###'] = t3lib_extMgm::siteRelPath($this->extKey).'pi1/css/'.$this->conf['defaultTheme'];
		}
		
		$markerArray['###INTROTEXT###'] = $introductory_text;
		$markerArray['###FULLTEXT###'] = $additional_text;
		$markerArray['###POSITION###'] = $iconPosition ;
		$markerArray['###SHAPE###'] = $iconType ;
		$markerArray['###THEME###'] = $iconTheme ;
		$markerArray['###EXTRAOPTION###'] = $extraoptions ;
		$markerArray['###COUNTRIES###'] = $countries;
		$markerArray['###CODE###'] = $anlayticsCode;
		$markerArray['###PATH###'] = t3lib_extMgm::siteRelPath($this->extKey);
		$markerArray['###STR_LEN_ADD_TEXT###'] = strlen(htmlentities($rte_additional_text));
		$markerArray['###TITLE###'] = $flexformValues["themeTitle"];
		//$markerArray['###BUTTON_TEXT###'] = $flexformValues["buttonText"];
		//$markerArray['###REVOKE_BUTTON_TEXT###'] = $flexformValues["revokeText"];
		$markerArray['###MODE###'] = $consentModel;
		
		session_start();
		ini_set('display_errors', 0);
		//echo '.'.$_SERVER['HTTP_HOST'];
		$flag = true;
		if($_REQUEST['user'] != "" && $_SESSION['disable_session'] == 1 && 	$flag ){
		$flag = false;
		if (isset($_SERVER['HTTP_COOKIE'])) {
				$cookies = explode(';', $_SERVER['HTTP_COOKIE']);
				foreach($cookies as $cookie) {
					$parts = explode('=', $cookie);
					$name = trim($parts[0]);
					if($name != 'PHPSESSID'){
						setcookie($name, '', time()-(60*60*24*365*10));
						setcookie($name, '', time()-(60*60*24*365*10), '/','.'.$_SERVER['HTTP_HOST']);
					}
				}
			}
			header("Location:".$_SERVER['HTTP_REFERER']);
			
		}
		if($_SESSION['disable_session'] == 1){
			if (isset($_SERVER['HTTP_COOKIE'])) {
				$cookies = explode(';', $_SERVER['HTTP_COOKIE']);
				foreach($cookies as $cookie) {
					$parts = explode('=', $cookie);
					$name = trim($parts[0]);
					if($name != 'PHPSESSID'){
						setcookie($name, '', time()-(60*60*24*365*10));
						setcookie($name, '', time()-(60*60*24*365*10), '/','.'.$_SERVER['HTTP_HOST']);
					}
				}
			}
		}
		return $this->cObj->substituteMarkerArray($tmpl, $markerArray);
	}

	function init(){
		$this->pi_initPIflexForm();
		$this->lConf = array(); // Setup o
		// Assign the flexform data to a local variable for easier access
		$piFlexForm = $this->cObj->data['pi_flexform'];
		// Traverse the entire array based on the language...
		// and assign each configuration option to $this->lConf array...
		foreach ( $piFlexForm['data'] as $sheet => $data ) {
			foreach ( $data as $lang => $value ) {
				foreach ( $value as $key => $val ) {
					$this->lConf[$key] = $this->pi_getFFvalue($piFlexForm, $key, $sheet);
				}
			}
		}
		return  $this->lConf;
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cookie_control/pi1/class.tx_cookiecontrol_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cookie_control/pi1/class.tx_cookiecontrol_pi1.php']);
}

?>